/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ARVTIPOCARD                                              */
/* Tabela : ARVTIPOCARD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 10/01/2005 - Henrique Dias Borges                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ARVTIPOCARD
BEFORE INSERT OR UPDATE OR DELETE
ON ARVTIPOCARD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUARVT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMPASTATCARD,0) <> NVL(:NEW.NMPASTATCARD,0)) OR
         (NVL(:OLD.NRNVPASTCARD,0) <> NVL(:NEW.NRNVPASTCARD,0)) OR
         (NVL(:OLD.NRPASTCARANT,0) <> NVL(:NEW.NRPASTCARANT,0)) THEN
         :NEW.DTULTATUARVT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ARVTIPOCARD', '', 'CDFILCENTPME='||:OLD.CDFILCENTPME||';NRPASTATCARD='||:OLD.NRPASTATCARD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ARVTIPOCARD MODIFY DTULTATUARVT DEFAULT SYSDATE
/

